﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using System.Drawing;
using Infragistics.Win.UltraWinEditors;

namespace _92210
{
    class ComboDraw : IUIElementDrawFilter
    {
        #region IUIElementDrawFilter Members

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is TextUIElement && drawParams.Element.Parent is ValueListItemUIElement)
            {
                ValueListItemUIElement par = (ValueListItemUIElement)drawParams.Element.Parent;
                Pen p = (Pen)par.ValueListItem.DataValue;
                Point start = drawParams.Element.Rect.Location;
                start.Offset(0, drawParams.Element.Rect.Height / 2);
                Point end = drawParams.Element.Rect.Location;
                end.Offset(drawParams.Element.Rect.Width, drawParams.Element.Rect.Height / 2);
                drawParams.Graphics.DrawLine(p, start, end);
                return true;
            }
            if (drawParams.Element is EditorWithTextUIElement)
            {
                ValueListItem par = ((UltraComboEditor)drawParams.Element.Control).SelectedItem;
                if (par != null)
                {
                    Pen p = (Pen)par.DataValue;
                    Point start = drawParams.Element.Rect.Location;
                    start.Offset(0, drawParams.Element.Rect.Height / 2);
                    Point end = drawParams.Element.Rect.Location;
                    end.Offset(drawParams.Element.Rect.Width, drawParams.Element.Rect.Height / 2);
                    drawParams.Graphics.DrawLine(p, start, end);
                    return true;
                }
            }
            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is TextUIElement || drawParams.Element is EditorWithTextUIElement)
                return DrawPhase.BeforeDrawElement;
            return DrawPhase.None;
        }

        #endregion
    }
}
